CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  DEBUG_BAUD = 9_600
  DEBUG_HEADING_X = 1          ' Output formatting data
  DEBUG_HEADING_Y = 1
  DEBUG_DYNAMIC_X = DEBUG_HEADING_X + 8
  DEBUG_DYNAMIC_Y = DEBUG_HEADING_Y + 2

VAR
  LONG cog_one_Stack[20]
  LONG cog_two_Stack[20]
  LONG cog_three_Stack[20]
  LONG cog_four_Stack[20]
  LONG cog_five_Stack[20]
  LONG cog_six_Stack[20]
  LONG cog_seven_Stack[20]
  
  BYTE cog[7]
  
OBJ
  Pst           : "Parallax Serial Terminal"


PUB main
  pause(1000)

  Pst.Start(DEBUG_BAUD)
  pause(500)
  cognew(cog_one, @cog_one_stack)
  pause(500)
  cognew(cog_two, @cog_two_stack)
  pause(500)
  cognew(cog_three, @cog_three_stack)
  pause(500)
  cognew(cog_four, @cog_four_stack)
  pause(500)
  cognew(cog_five, @cog_five_stack)
  pause(500)
  cognew(cog_six, @cog_six_stack)
  pause(500)
  cognew(cog_seven, @cog_seven_stack)
  
  Pst.Clear
  Pst.Position(DEBUG_HEADING_X, DEBUG_HEADING_Y)
  Pst.Str(string("Cog Variable Value", 13))
  Pst.PositionX(DEBUG_HEADING_X)
  Pst.Str(string("------------------------", 13))
  Pst.PositionX(DEBUG_HEADING_X)
  Pst.Str(string("Zero  ................", 13))
  Pst.PositionX(DEBUG_HEADING_X)
  Pst.Str(string("One  ................", 13))
  Pst.PositionX(DEBUG_HEADING_X)
  Pst.Str(string("Two ...............", 13))
  Pst.PositionX(DEBUG_HEADING_X)
  Pst.Str(string("Three ...............", 13))
  Pst.PositionX(DEBUG_HEADING_X)
  Pst.Str(string("Four  .................", 13))
  Pst.PositionX(DEBUG_HEADING_X)
  Pst.Str(string("Five  ................", 13))
  Pst.PositionX(DEBUG_HEADING_X)
  Pst.Str(string("Six ...............", 13))
  Pst.PositionX(DEBUG_HEADING_X)
  Pst.Str(string("Seven ...............", 13))

  repeat
     Update_Debug_Window
     cog[0]++

PUB cog_one
  repeat
    cog[1]++
    pause(100)
  
PUB cog_two
  repeat
    cog[2]++
    pause(200)

PUB cog_three
  repeat
    cog[3]++
    pause(300)

PUB cog_four
  repeat
    cog[4]++
    pause(400)

PUB cog_five
  repeat
    cog[5]++
    pause(500)

PUB cog_six
  repeat
    cog[6]++
    pause(600)

PUB cog_seven
  repeat
    cog[7]++
    pause(700)
      
PUB Update_Debug_Window
    Pst.Position(DEBUG_DYNAMIC_X, DEBUG_DYNAMIC_Y)
    Pst.Dec(cog[0])
    Pst.Str(string("..."))
    Pst.Position(DEBUG_DYNAMIC_X, DEBUG_DYNAMIC_Y + 1)
    Pst.Dec(cog[1])
    Pst.Str(string("..."))
    Pst.Position(DEBUG_DYNAMIC_X, DEBUG_DYNAMIC_Y + 2)
    Pst.Dec(cog[2])
    Pst.Str(string("..."))
    Pst.Position(DEBUG_DYNAMIC_X, DEBUG_DYNAMIC_Y + 3)
    Pst.Dec(cog[3])
    Pst.Str(string("..."))
    Pst.Position(DEBUG_DYNAMIC_X, DEBUG_DYNAMIC_Y + 4)
    Pst.Dec(cog[4])
    Pst.Str(string("..."))
    Pst.Position(DEBUG_DYNAMIC_X, DEBUG_DYNAMIC_Y + 5)
    Pst.Dec(cog[5])
    Pst.Str(string("..."))
    Pst.Position(DEBUG_DYNAMIC_X, DEBUG_DYNAMIC_Y + 6)
    Pst.Dec(cog[6])
    Pst.Str(string("..."))
    Pst.Position(DEBUG_DYNAMIC_X, DEBUG_DYNAMIC_Y + 7)
    Pst.Dec(cog[7])
    Pst.Str(string("..."))
    return

PUB pause(Duration)
  if(Duration > 0)  
    waitcnt((clkfreq / 1_000 * Duration) + cnt)
  return